<?php


namespace app\cbcrm\controller\admin;


use app\cbcrm\controller\BaseAdmin;
use think\facade\Db;
use think\Request;


class System extends BaseAdmin
{
    public function __construct(Request $request)
    {
        parent::__construct($request);
    }

    public function index()
    {
        $version = file_get_contents(app()->getAppPath().'upgradex/version.txt');
        $last_update_time = Db::table('cb_crm_system_update')->order('create_time', 'desc')->value('create_time');
        $list = Db::table('cb_crm_system_update')->order('create_time', 'desc')->select();

        $this->success('返回成功',compact('version','last_update_time','list'));
    }

    public function checkUpdate()
    {
        $check = $this->check();
        if ($check['code']!=1) {
           $this->error($check['msg']);
        }
        include_once app_path('library/update').'upgrade.php';
    }

    public function upgrade()
    {
        include_once app_path('library/update').'upgrade.php';
    }

    /**
     * 检测是否有授权更新资格
     * @return array
     */
    protected function check()
    {

        if(!isset($_SESSION['authcode']) || $_SESSION['authcode'] != 'd38ad3a8081'){
            $hosts = $_SERVER['HTTP_HOST'].'|'.$_SERVER['SERVER_NAME'];
            $ckret = file_get_contents('http://crmupdate.vcb.cn/check.php?a=index&appsign=17_231229170934496_3284c809_1bda5296b8b457f4dbdc99664a4f8d57&h=' . urlencode($hosts) . '&t=' . $_SERVER['REQUEST_TIME'] . '&token=' . md5($_SERVER['REQUEST_TIME'] . '|' . $hosts . '|xzphp|d38ad3a808'));
            if($ckret){
                $ckret = json_decode($ckret, true);
                if($ckret['status'] != 1){
                    return ['code'=>0,'msg'=>$ckret['msg']];
                }else{
                    return ['code'=>1,'msg'=>'success','data'=>$ckret];
                }
            }else{
                return ['code'=>0,'msg'=>'授权检测失败，请联系授权提供商。'];
            }
        }

    }
}
