<?php

declare (strict_types = 1);

namespace app\cbcrm\middleware;
use think\facade\Db;
use think\facade\Session;

class membercheck
{
    protected $whiteList = [
        '/',
    ];
    /**
     * 处理请求
     *
     * @param \think\Request $request
     * @param \Closure       $next
     * @return Response
     */

    public function handle($request, \Closure $next)
    {
        $token = Session::get('memberToken');
        if(request()->get('memberToken')){
            Session::set('memberToken',request()->get('memberToken'));
            return redirect($request->domain().$request->baseUrl());
        }
        $url   = strtolower($request->baseUrl()); //获取url地址, 不带域名,然后小写,
        if(in_array($url,$this->whiteList)) return $next($request);
        if(!$token) {
            return redirect(prefix_url(false).'/login.html');
        }
        $member = Db::table('cb_crm_user_token')->where([['token', '=', $token],['expire_time','>',time()]])->find();
        if(!$member) return redirect(prefix_url(false).'/login.html');
        Db::table('cb_crm_user_token')->where('id',$member['id'])->update(['expire_time'=> time() + (7*24*3600)]);
        return $next($request);

    }
}
